
	device ZXSPECTRUM48


		org 24000

start:
		call black_cls

		ld a,7*8
		call col_scr

		ld bc,font8x8
		ld (font),bc

		ld de,$0705
		call xy2scr
		ld ix,str1
		call pr_str8x8

		ld bc,graph8x8
		ld (font),bc
		
		ld de,$0805
		ld (xy2),de
		call paint_setka

		ld de,$0812
		ld (xy2),de
		call paint_setka

		ld hl,(fnt1)
		ld de,$0000
		call pr_font

		call fnt1_2fnt2

		ld hl,(fnt2)
		ld de,$0300
		call pr_font

		ld bc,(fnt2)
		ld (font),bc

.rep:		call slm2flags

		ld de,$0805
		ld bc,(fnt1)
		ld a,(smb_n)
		call paint_smb

		ld de,$0705
		ld hl,flags
		call paint_flags

		ld de,$0812
		ld bc,(fnt2)
		ld a,(smb_n)
		call paint_smb

		ld l,7
		call paint_cursors

		ld de,(xy)
		call xy2scr
		ld bc,(fnt2)
		ld (font),bc
		ld a,(smb_n)
		sub 32
		call pr_smb8x8


.k1:		halt
		call scan_keys
		ld a,(keys_buf)
		or a
		jr z,.k1

		cp 39 ;"N"
		jr nz,.k10
		ld a,(smb_n)
		dec a
		cp 32
		jr c,.k2
		jr .k10m1

.k10:		cp 38 ;"M"
		jr nz,.k11
		ld a,(smb_n)
		inc a
		cp 128
		jr nc,.k10m2
.k10m1:		push af
		ld l,7*8
		call paint_cursors
		pop af
		ld (smb_n),a
.k10m2:		jp .k2

.k11:		cp 16	;"1"
		jr c,.k12
		cp 21	;"5"
		jr nc,.k12
		or a
		sbc 16
		jr .k12m1

.k12:		cp 26	;"6"
		jr nc,.k13
		cp 23	;"8"
		jr c,.k13
		sbc 23
		neg
		add 7
.k12m1:		ld c,a
		ld b,0
		ld hl,flags
		add hl,bc
		ld a,(hl)
		cpl
		ld (hl),a
		call flags2slm
		call slm_smb
		jp .k2
		

.k13:

.k2:		ld a,5
		ld (pause),a
.k2m1:		halt
		ld a,(pause)
		dec a
		jr z,.k2m2
		ld (pause),a
		call scan_keys
		ld a,(keys_buf)
		or a
		jr nz,.k2m1
.k2m2:

		jp .rep


fnt1:		defb 0,61

fnt2:		defw font2

font:		defw 0

smb_n:		defb 64

str1:		defb "12345678",0

flags:		defb 0,0,1,0,1,0,1,0

keys_buf:	defb 0,0,0,0,0,0,0,0,0

pause:		defb 0



;after flags2smb
;
slm_smb:	push hl
		pop ix
		ld h,0
		ld a,(smb_n)
		sub 32
		ld l,a
		add hl,hl
		add hl,hl
		add hl,hl
		push hl
		ld bc,(fnt2)
		add hl,bc
		ex de,hl
		pop hl
		ld bc,(fnt1)
		add hl,bc
		call fnt1_2fnt2.convert
		ret		
		
		


flags2slm:	ld h,0
		ld a,(smb_n)
		sub 32
		ld l,a
		ld bc,buf_slm
		add hl,bc
		ld de,flags
		ld b,8
.m1:		ld a,(de)
		sub 1
		ccf
		rl c
		inc de
		djnz .m1
		ld (hl),c
		ret


;L - set o reset, color
;
paint_cursors:	ld a,(smb_n)
		sub 32
		ld bc,$0300
.m2:		cp 32
		jr c,.m1
		sbc 32
		inc c
		djnz .m2
.m1:		ld d,c
		ld e,a
		ld (xy),de
		call xy2atr
		ld a,L
		ld (de),A
		push hl
		ld hl,$0300
		ld de,(xy)
		add hl,de
		ld (xy),hl
		ex de,hl
		call xy2atr
		pop hl
		ld a,L
		ld (de),A
		ret


slm2flags:	ld h,0
		ld a,(smb_n)
		sub 32
		ld l,a
		ld bc,buf_slm
		add hl,bc
		ld de,flags
		ld b,8
		ld a,(hl)
.m2:		rlca
		push af
		ld a,$FF
		jr c,.m1
		xor a
.m1:		ld (de),a
		inc de
		pop af
		djnz .m2
		ret



fnt1_2fnt2:	ld ix,buf_slm
		ld hl,(fnt1)
		ld de,(fnt2)
		ld c,96
.m2:		call .convert
		inc ix
		dec c
		jr nz,.m2
		ret

.convert:	ld b,8
.m1:		push bc
		push de
		ld a,(hl)
		inc hl
		ld d,(ix)
		ld b,8
.m5:		rr d
		jr nc,.m3
		rrca
		rr c
		jr .m4
.m3:		rrca
.m4:		djnz .m5
		ld a,c
		pop de
		pop bc
		ld (de),a
		inc de
		djnz .m1
		ret


;DE - XY
;HL - font
;
pr_font:	call xy2scr
		ld c,96
.m2:		ld b,7
.m1:		ld a,(hl)
		ld (de),a
		inc hl
		inc d
		djnz .m1
		ld a,(hl)
		ld (de),a
		inc hl
		call nxt_pr8x8
		dec c
		jr nz,.m2
		ret


;DE - XY
;HL - flags
;
paint_flags:	call xy2atr
		ld b,8
.m1:		ld a,(hl)
		inc hl
		or a
		push af
		ld a,7*8
		jr z,.m2
		ld a,7
.m2:		ld (de),a
		inc de
		pop af
		djnz .m1
		ret


;DE - XY
;A - smb
;BC - fnt
;
paint_smb:	sub 32
		ld h,0
		ld l,a
		add hl,hl
		add hl,hl
		add hl,hl
		add hl,bc
		call xy2atr
		ld c,8
.m3:		ld a,(hl)
		inc hl
		ld b,8
.m2:		rlca
		push af
		ld a,7
		jr c,.m1
		ld a,7*8
.m1:		ld (de),a
		inc de
		pop af
		djnz .m2
		ld a,e
		add 32-8
		ld e,a
		ld a,d
		adc 0
		ld d,a
		dec c
		jr nz,.m3
		ret

		
;xy2 - coord. offset
;
paint_setka:	ld de,0
.m1:		ld (xy),de
		ld hl,(xy2)
		add hl,de
		ex de,hl
		call xy2scr
		ld a,1
		call pr_smb8x8
		ld de,(xy)
		inc e
		ld a,8
		cp e
		jr nz,.m1
		ld e,0
		inc d
		cp d
		jr nz,.m1
		ret
		


xy2		defw 0

xy		defw 0

		include "print8x8g.asm"

		include "color_line_etc.asm"

		include "keys.asm"

graph8x8:	include "fced8x8graph.asm"

font8x8:	equ 60*256

	defb "BUF_SLM"

buf_slm:	incbin "font4x8slm-FF.bin"
;96
	defb "NEW_FONT"

font2:		

		org font2+768

	defb "END_FONT"

	SAVESNA "font-convert-ed.sna",start

	LABELSLIST "fced-list.txt"